-
Notifications
You must be signed in to change notification settings - Fork 0
/
Copy pathProblem_STOII_0046_rightSideView.cc
110 lines (100 loc) · 2.5 KB
/
Problem_STOII_0046_rightSideView.cc
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
#include <iostream>
#include <queue>
#include <unordered_map>
#include <vector>
using namespace std;
struct TreeNode
{
int val;
TreeNode *left;
TreeNode *right;
TreeNode() : val(0), left(nullptr), right(nullptr) {}
TreeNode(int x) : val(x), left(nullptr), right(nullptr) {}
TreeNode(int x, TreeNode *left, TreeNode *right) : val(x), left(left), right(right) {}
};
// seem as leetcode 0199
// https://leetcode-cn.com/problems/binary-tree-right-side-view/
// see at Problem_0199_rightSideView.cc
class Solution
{
public:
// dfs
vector<int> rightSideView1(TreeNode *root)
{
if (root == nullptr)
{
return {};
}
unordered_map<int, int> map;
int max_depth = -1;
// 这里是栈
vector<tuple<TreeNode *, int>> stack;
stack.push_back({root, 0});
while (!stack.empty())
{
// 注意这里不能用引用,因为 后面有 pop_back 导致引用失效
// auto &[node, depth] = stack.back();
auto [node, depth] = stack.back();
stack.pop_back();
// 更新最大深度
max_depth = std::max(max_depth, depth);
if (map.find(depth) == map.end())
{
// 第一次访问,记录节点值
map.emplace(depth, node->val);
}
if (node->left)
{
stack.push_back({node->left, depth + 1});
}
// 因为 right 是最后进栈,那么优先出栈访问
if (node->right)
{
stack.push_back({node->right, depth + 1});
}
}
vector<int> ans;
for (int i = 0; i <= max_depth; i++)
{
ans.push_back(map[i]);
}
return ans;
}
// bfs
vector<int> rightSideView2(TreeNode *root)
{
if (root == nullptr)
{
return {};
}
unordered_map<int, int> map;
int max_depth = -1;
// 这里是队列
queue<tuple<TreeNode *, int>> q;
q.push({root, 0});
while (!q.empty())
{
// 注意这里不能用引用,因为 后面有 pop 会导致引用失效
auto [node, depth] = q.front();
q.pop();
// 更新最大深度
max_depth = std::max(max_depth, depth);
// 由于每一层最后一个访问到的节点才是我们要的答案,因此不断更新对应深度的信息即可
map[depth] = node->val;
if (node->left)
{
q.push({node->left, depth + 1});
}
if (node->right)
{
q.push({node->right, depth + 1});
}
}
vector<int> ans;
for (int i = 0; i <= max_depth; i++)
{
ans.push_back(map[i]);
}
return ans;
}
};